use thiserror::Error;

mod multiplexer;

#[derive(Error, Debug)]
pub enum CnrError {
    #[error("Version mismatch.")]
    VersionMismatch,

    #[error("Ser/deserialisation error.")]
    Serde(#[from] serde_bare::error::Error),

    #[error("Input/output error.")]
    Io(#[from] std::io::Error),

    #[error("Channel closed.")]
    Closed,
}

pub use multiplexer::Channel;
pub use multiplexer::ChannelHandle;
pub use multiplexer::ChannelLock;
pub use multiplexer::TransportMultiplexer;
